// AlarmAdvanceSetter.cpp : ʵļ
//

#include "stdafx.h"
#include "ClientDemo.h"
#include "AlarmAdvanceSetter.h"
#include "afxdialogex.h"
#include "GeneralDef.h"

const char* szEventTypeZn[] = { "ź", "ƶ", "Ƶʧ", "ڵ", "",
"齹", "Ƶ쳣", "", "", "Խ⣨Խߣ",
"", "뿪", "ǻ", "ۼ", "ƶ", "ͣ", "Ʒ",
"Ʒȡ", "PIR", "", "±", "Ԥ", "²", "",
"", "̻", "ֻ", "Ӳ", "Ӳ̴", "Ͽ",
"IPַͻ", "Ƿ", "ץ", "ȶ", "ȶԣİ˱ȶԣ", "Ŀץ",
"ʶ", "Աܶ", "ͨ¼", "ץĽģ", "ϴ", "ȶͼ", "ͼƬʶ",
"֤ȶ", "ڼ", "仯", "Ա", "˶", "Ա", "Ա¼", "ƵԱ",
"ȱ쳣", "POE쳣", "Ƶ쳣", "¼쳣", "Ӳδʼ", "Ӳ쳣", "쳣",
"ͼƬ", "Ⱥϵͳ洢쳣", "Ⱥ汾쳣", "쳣", "¼ڲ",
"IPCǨʧ", "ȫñ", "ǩϢϴ", "վϢϴ", "Ƶ豸¼", "Ž¼",
"ӶԽ豸¼ϴ", "ӶԽ豸ϴ", "Ŷʱ", "Ŷ", "ԱŶӼʵʱϱ",
"Ŀ", "ǻ۳ǹ", "Ƶ쳣", "VQD" };

const char* szEventType[] = { "IO", "VMD", "videoloss", "shelteralarm", "facedetection",
"defocus", "audioexception", "scenechangedetection", "fielddetection", "linedetection",
"regionEntrance", "regionExiting", "loitering", "group", "rapidMove", "parking", "unattendedBaggage",
"attendedBaggage", "PIR", "PeopleCounting", "TMA", "TMPA", "temperature", "fireDetection",
"smokeDetection", "smokeAndFireDetection", "shipsDetection", "diskfull", "diskerror", "nicbroken",
"ipconflict", "illaccess", "faceCapture", "alarmResult", "whiteFaceContrast", "targetCapture",
"ANPR", "personDensityDetection", "AID", "faceSnapModeling", "vehicleMatchResult", "heatmap", "vehicleRcogResult",
"cardMatch", "leavePosition", "peopleNumChange", "running", "violentMotion", "failDown", "retention", "HFPD",
"hotSpare", "poe", "videoException", "recordException", "diskUnformat", "facelibDiskError", "facelibModifyError",
"facelibPictureError", "sysStorFull", "versionAbnormal", "nodeOffline", "recordCycleAbnormal",
"ipcTransferAbnormal", "safetyHelmetDetection", "tagInfo", "baseStationInfo", "IOTD", "AccessControllerEvent",
"VideoIntercomEvent", "VideoIntercomAlarm", "personQueueTime", "personQueueCounting", "personQueueRealTime",
"mixedTargetDetection", "cityManagement", "pocException", "VQDDiagnose" };

// CAlarmAdvanceSetter Ի

IMPLEMENT_DYNAMIC(CAlarmAdvanceSetter, CDialogEx)

CAlarmAdvanceSetter::CAlarmAdvanceSetter(CWnd* pParent /*=NULL*/)
    : CDialogEx(CAlarmAdvanceSetter::IDD, pParent)
    , m_bChePaiBroken(FALSE)
    , m_bKeLiuTongJiBroken(FALSE)
    , m_bHotMapBroken(FALSE)
    , m_bFaceSanpBroken(FALSE)
    , m_bFaceMatchBroken(FALSE)
    , m_bCopilotFace(FALSE)
    , m_iTaskNo(0)
    , m_bConfirmMechanism(FALSE)
    , m_pData(NULL)
    , m_bIsSupoortSubscribe(FALSE)
    , m_iDeviceIndex(-1)
    , m_bJsonPass(FALSE)
    , m_bIsSupportBehaviorUploadByCloudStorageURL(FALSE)
    , m_bChannelEnable(FALSE)
    , m_strSubscribe(_T(""))
    , m_bUploadAll(FALSE)
    , m_bUploadChannel(FALSE)
    , m_bUploadHd(FALSE)
    , m_bUploadCapability(FALSE)
    , m_bCheckSubcribeCap(FALSE)
    , m_bEnableXml(FALSE)
    , m_bChkHeatMapDurationPDC(FALSE)
    , m_bChkHeatMapIntersection(FALSE)
    , m_bRetAlarmTypeV40(FALSE)
    , m_bNVRAlarmIPC(FALSE)
    , m_bVMDPic(FALSE)
    , m_bAidBroken(FALSE)
    , m_bTfsBroken(FALSE)
    , m_bTPsStatBroken(FALSE)
{
    //m_bIsSupportAlarmLevel = FALSE;
    //m_bIsSupportITSUploadType = FALSE;
    //m_bIsSupportAlarmTypeV40 = FALSE;
    //m_bIsSupportDevInfoVersion = FALSE;
    m_bIsSupportFaceSnap = FALSE;
    m_bIsSupportFaceDetection = FALSE;
    //m_bIsSupportChePaiBroken = FALSE;
    m_iRowCount = 0;
    m_iSubItem = -1;
    m_iLastItem = -1;

    memset(m_listSubcirbeEventCap, 0, MAX_EVENT_TYPE_NUM * sizeof(SubcirbeEventCap));

    m_strAllPictureUrlType = _T("");

    //m_bIsSupportFaceSanpBroken = FALSE;
    //m_bIsSupportFaceMatchBroken = TRUE;
}

CAlarmAdvanceSetter::~CAlarmAdvanceSetter()
{
}

void CAlarmAdvanceSetter::DoDataExchange(CDataExchange* pDX)
{
    CDialogEx::DoDataExchange(pDX);
    DDX_Control(pDX, IDC_COMBO_ALARM_RANK, m_cmbAlarmLevel);
    DDX_Control(pDX, IDC_COMBO_ALARM_TYPE, m_cmbAlarmType);
    DDX_Control(pDX, IDC_COMBO_FACE_DETECT_TYPE, m_cmbFaceDetectType);
    DDX_Check(pDX, IDC_CHECK_FACE_MATCH_BROKEN, m_bFaceMatchBroken);
    DDX_Control(pDX, IDC_COMBO_ITS_UPLOAD_TYPE, m_cmbITSUploadType);
    DDX_Check(pDX, IDC_CHECK_CHEPAI_BROKEN, m_bChePaiBroken);
    DDX_Check(pDX, IDC_CHECK_KELIUTONGJI_BROKEN, m_bKeLiuTongJiBroken);
    DDX_Check(pDX, IDC_CHECK_HotMap_BROKEN, m_bHotMapBroken);
    DDX_Check(pDX, IDC_CHECK_FACE_SNAP_BROKEN, m_bFaceSanpBroken);
    DDX_Control(pDX, IDC_COMBO_FACE_SNAP_DATA_TYPE, m_cmbFaceSnapDataType);
    DDX_Control(pDX, IDC_COMBO_FACE_MATCH_DATA_TYPE, m_cmbFaceMatchDataType);
    DDX_Control(pDX, IDC_COMBO_EVENT_JSON_DATA_TYPE, m_cmbEventJsonDataType);
    DDX_Check(pDX, IDC_CHECK_COPILOT_FACE, m_bCopilotFace);
    DDX_Text(pDX, IDC_EDIT_TASK_NUMBER, m_iTaskNo);
    DDX_Control(pDX, IDC_COMBO_ALARM_SUBSCRIBE_INFO, m_cmbAlarmSubscribeInfo);
    DDX_Check(pDX, IDC_CHECK_CONFIRM_MECHANISM, m_bConfirmMechanism);
    DDX_Check(pDX, IDC_CHECK_JSON_PASS, m_bJsonPass);
    DDX_Control(pDX, IDC_COMBO_BEHAVIOR, m_cmbBehavior);
    DDX_Control(pDX, IDC_LIST_CHAN, m_listChan);
    DDX_Check(pDX, IDC_CHECK_CHANNEL_ENABLE, m_bChannelEnable);
    DDX_Control(pDX, IDC_COMBO_PICTURE_URL_TYPE, m_comboPictureUrlType);
    DDX_Control(pDX, IDC_COMBO_EVENT_TYPE, m_comboEventType);
    DDX_Control(pDX, IDC_LIST_EVENT_PARAM, m_listEventParam);
    DDX_Check(pDX, IDC_CHECK_UPLOAD_ALL, m_bUploadAll);
    DDX_Check(pDX, IDC_CHECK_UPLOAD_CHANNEL, m_bUploadChannel);
    DDX_Check(pDX, IDC_CHECK_UPLOAD_HD, m_bUploadHd);
    DDX_Check(pDX, IDC_CHECK_UPLOAD_CAPABILITY, m_bUploadCapability);
    DDX_Check(pDX, IDC_CHECK_SUBCRIBE_CAP, m_bCheckSubcribeCap);
    DDX_Check(pDX, IDC_CHK_ENABLE_XML, m_bEnableXml);
    DDX_Check(pDX, IDC_CHECK_HEATMAP_PDC_DURATION_BROKEN, m_bChkHeatMapDurationPDC);
    DDX_Check(pDX, IDC_CHECK_INTERSECTION_ANALYSIS_BROKEN, m_bChkHeatMapIntersection);
    DDX_Check(pDX, IDC_CHECK_ALARMTYPE_V40, m_bRetAlarmTypeV40);
    DDX_Check(pDX, IDC_CHECK_ALL_ALARM, m_bNVRAlarmIPC);
    DDX_Check(pDX, IDC_CHECK_VMD, m_bVMDPic);
    DDX_Check(pDX, IDC_CHECK_AID_BROKEN, m_bAidBroken);
    DDX_Check(pDX, IDC_CHECK_TFS_BROKEN, m_bTfsBroken);
    DDX_Check(pDX, IDC_CHECK_TPS_STATISTIC_BROKEN, m_bTPsStatBroken);
}


BEGIN_MESSAGE_MAP(CAlarmAdvanceSetter, CDialogEx)
    ON_CBN_SELCHANGE(IDC_COMBO_ALARM_SUBSCRIBE_INFO, &CAlarmAdvanceSetter::OnCbnSelchangeComboAlarmSubscribeInfo)
    ON_BN_CLICKED(IDC_BUTTON_CONFIRM, &CAlarmAdvanceSetter::OnBnClickedButtonConfirm)
    ON_BN_CLICKED(IDC_BTN_XMLSUB, &CAlarmAdvanceSetter::OnBnClickedBtnXmlsub)
    ON_BN_CLICKED(IDC_BUTTON_GET_SUBSCRIBE, &CAlarmAdvanceSetter::OnBnClickedButtonGetSubscribe)
    ON_BN_CLICKED(IDC_BUTTON_SET_SUBSCRIBE, &CAlarmAdvanceSetter::OnBnClickedButtonSetSubscribe)
    ON_BN_CLICKED(IDC_BUTTON_ADD_PARAM, &CAlarmAdvanceSetter::OnBnClickedButtonAddParam)
    ON_BN_CLICKED(IDC_BUTTON_DELETE, &CAlarmAdvanceSetter::OnBnClickedButtonDeleteParam)
    ON_NOTIFY(NM_CLICK, IDC_LIST_EVENT_PARAM, &CAlarmAdvanceSetter::OnNMClickListEventParam)
    ON_BN_CLICKED(IDC_CHECK_CHANNEL_ENABLE, &CAlarmAdvanceSetter::OnBnClickedCheckChannelEnable)
    ON_CBN_SELCHANGE(IDC_COMBO_EVENT_TYPE, &CAlarmAdvanceSetter::OnCbnSelchangeComboEventType)
    ON_BN_CLICKED(IDC_CHECK_SUBCRIBE_CAP, &CAlarmAdvanceSetter::OnBnClickedCheckSubcribeCap)
END_MESSAGE_MAP()

BOOL CAlarmAdvanceSetter::OnInitDialog()
{
    CDialogEx::OnInitDialog();

    // TODO:  ڴӶĳʼ

    //Ĭѡ
    m_cmbAlarmLevel.SetCurSel(0);
    m_cmbAlarmType.SetCurSel(0);  //ĬΪͻ˲
    m_cmbFaceDetectType.SetCurSel(1);  //ĬΪⱨ
    m_cmbITSUploadType.SetCurSel(1);//ĬΪ±
    m_cmbAlarmSubscribeInfo.SetCurSel(0);  //ĬΪAll
    m_cmbFaceMatchDataType.SetCurSel(0);   //ĬΪ
    m_cmbFaceSnapDataType.SetCurSel(0);    //ĬΪ
    m_cmbEventJsonDataType.SetCurSel(0);   //ĬΪ
    m_cmbBehavior.SetCurSel(0);   //ĬΪ

    //ΪѡĬֵ
    m_bFaceSanpBroken = FALSE;
    m_bFaceMatchBroken = FALSE;
    m_bHotMapBroken = FALSE;
    m_bKeLiuTongJiBroken = FALSE;
    m_bChePaiBroken = FALSE;
    m_bConfirmMechanism = FALSE;
    m_bCopilotFace = FALSE;
    m_iTaskNo = FALSE;
    m_bJsonPass = FALSE;
    m_bChkHeatMapDurationPDC = FALSE;
    m_bChkHeatMapIntersection = FALSE;

    m_bAidBroken = FALSE;
    m_bTfsBroken = FALSE;
    m_bTPsStatBroken = FALSE;

    //ĬϿбϢ
    m_cmbAlarmLevel.EnableWindow(TRUE);
    m_cmbAlarmType.EnableWindow(TRUE);
    m_cmbFaceDetectType.EnableWindow(TRUE);
    m_cmbITSUploadType.EnableWindow(TRUE);
    m_cmbFaceMatchDataType.EnableWindow(TRUE);
    m_cmbFaceSnapDataType.EnableWindow(TRUE);
    m_cmbEventJsonDataType.EnableWindow(TRUE);

    m_bChannelEnable = FALSE;

    GetDlgItem(IDC_COMBO_FACE_SNAP_DATA_TYPE)->EnableWindow(TRUE);
    GetDlgItem(IDC_COMBO_FACE_MATCH_DATA_TYPE)->EnableWindow(TRUE);
    GetDlgItem(IDC_COMBO_EVENT_JSON_DATA_TYPE)->EnableWindow(TRUE);
    GetDlgItem(IDC_COMBO_BEHAVIOR)->EnableWindow(TRUE);
    
    GetDlgItem(IDC_CHECK_CONFIRM_MECHANISM)->EnableWindow(TRUE);
    GetDlgItem(IDC_CHECK_CHEPAI_BROKEN)->EnableWindow(TRUE);
    GetDlgItem(IDC_CHECK_KELIUTONGJI_BROKEN)->EnableWindow(TRUE);
    GetDlgItem(IDC_CHECK_HotMap_BROKEN)->EnableWindow(TRUE);
    GetDlgItem(IDC_CHECK_FACE_SNAP_BROKEN)->EnableWindow(TRUE);
    GetDlgItem(IDC_CHECK_FACE_MATCH_BROKEN)->EnableWindow(TRUE);
    GetDlgItem(IDC_CHECK_COPILOT_FACE)->EnableWindow(TRUE);
    GetDlgItem(IDC_EDIT_TASK_NUMBER)->EnableWindow(TRUE);

    GetDlgItem(IDC_CHECK_AID_BROKEN)->EnableWindow(TRUE);
    GetDlgItem(IDC_CHECK_TFS_BROKEN)->EnableWindow(TRUE);
    GetDlgItem(IDC_CHECK_TPS_STATISTIC_BROKEN)->EnableWindow(TRUE);
    if (!m_bIsSupoortSubscribe)
    {
        m_cmbAlarmSubscribeInfo.EnableWindow(FALSE);
        GetDlgItem(IDC_CHECK_CHANNEL_ENABLE)->EnableWindow(FALSE);
        GetDlgItem(IDC_COMBO_EVENT_TYPE)->EnableWindow(FALSE);
        GetDlgItem(IDC_COMBO_PICTURE_URL_TYPE)->EnableWindow(FALSE);
        GetDlgItem(IDC_CHK_ENABLE_XML)->EnableWindow(FALSE);
    }

    m_bIsSupportFaceSnap = FALSE;
    m_bIsSupportFaceDetection = FALSE;

    OnBnClickedCheckChannelEnable();
    OnCbnSelchangeComboAlarmSubscribeInfo();

    InitEventType();

    //LISTϱϢ
    //GetDlgItem(IDC_STATIC_LIST_SUBSCRIBE_LIST)->EnableWindow(FALSE);

    //Fortify.cppļ, ѡ豸Ϊm_iDeviceIndex=-1
    if (m_iDeviceIndex != -1)
    {
        setDeviceAbility();
        GetSubcribeCapability();
        m_bCheckSubcribeCap = TRUE;
        GetDlgItem(IDC_CHECK_SUBCRIBE_CAP)->EnableWindow(TRUE);
    }
    else
    {
        GetDlgItem(IDC_CHECK_SUBCRIBE_CAP)->EnableWindow(FALSE);
    }

    m_listChan.SetExtendedStyle(m_listChan.GetExtendedStyle() | LVS_EX_CHECKBOXES);
    UpdateChanStatus();

    m_listEventParam.SetExtendedStyle(m_listEventParam.GetExtendedStyle() | LVS_EX_GRIDLINES | LVS_EX_FULLROWSELECT | LVS_EX_SUBITEMIMAGES);
    m_listEventParam.DeleteAllItems();
    char szLan[128] = { 0 };
    g_StringLanType(szLan, "", "Index");
    m_listEventParam.InsertColumn(0, szLan, LVCFMT_LEFT, 60, -1);

    g_StringLanType(szLan, "¼", "EventType");
    m_listEventParam.InsertColumn(1, szLan, LVCFMT_LEFT, 120, -1);

    g_StringLanType(szLan, "ͨ", "Channels");
    m_listEventParam.InsertColumn(2, szLan, LVCFMT_LEFT, 120, -1);

    g_StringLanType(szLan, "ͼƬ", "PictureType");
    m_listEventParam.InsertColumn(3, szLan, LVCFMT_LEFT, 120, -1);

    if (g_struDeviceInfo[m_iDeviceIndex].lFortifyHandle >= 0)
    {
        GetDlgItem(IDC_BUTTON_GET_SUBSCRIBE)->EnableWindow(TRUE);
        GetDlgItem(IDC_BUTTON_SET_SUBSCRIBE)->EnableWindow(TRUE);
    }
    else
    {
        GetDlgItem(IDC_BUTTON_GET_SUBSCRIBE)->EnableWindow(FALSE);
        GetDlgItem(IDC_BUTTON_SET_SUBSCRIBE)->EnableWindow(FALSE);
    }

    UpdateData(FALSE);
    return TRUE;  // return TRUE unless you set the focus to a control
    // 쳣:  OCX ҳӦ FALSE
}


/////////////////////////////////////////////////////////////////////////////
/*********************************************************
Function:  CheckITDeviceAbility
Desc:      Get the ITDeviceAbility ability based on the DevieceIndex
           maximize the alarm ability(one channel supports means all channel support)
Input:     none
Output:    none
Return:    none
**********************************************************/
void CAlarmAdvanceSetter::CheckITDeviceAbility()
{
    //ѯ ITDeviceAbility
    /*ȼã 1.ӿڵóɹ2.жڵ<ITDeviceAbility>е<ITCAbility>ֻҪھͱʾֲ֧ȼã
      Ƿϴʻͼ :  1.ӿڵóɹ2.жڵ<ITDeviceAbility>е<ITCAbility>ʾ豸ǽͨ豸ֻнͨ豸ָ֧ùܣ
      ܽͨϢϴ: 1.ӿڵóɹ 2.жڵ<ITDeviceAbility>е<TrafficDataUpload>*/
    DWORD dwAbilityType = DEVICE_ABILITY_INFO;
    char pInBuf[512] = "";
    DWORD dwOutputLen = 1024 * 1024;
    char *pOutBuf = new char[dwOutputLen];

    BOOL bIsSupportAlarmLevel = FALSE;
    BOOL bIsSupportITSUploadType = FALSE;
    BOOL bIsSupportCopilotFace = FALSE;

    for (int iChannelindex = 0; iChannelindex < g_struDeviceInfo[m_iDeviceIndex].iDeviceChanNum; iChannelindex++)
    {
        if (g_struDeviceInfo[m_iDeviceIndex].pStruChanInfo[iChannelindex].bEnable == FALSE)
        {
            continue;
        }
        sprintf(pInBuf, "<ITDeviceAbility version = \"2.0\">\r\n \
                         <channelNO>%d</channelNO>\r\n \
                         </ITDeviceAbility>", iChannelindex + 1);
        memset(pOutBuf, 0, dwOutputLen);
        if (NET_DVR_GetDeviceAbility(g_struDeviceInfo[m_iDeviceIndex].lLoginID, dwAbilityType, pInBuf, strlen(pInBuf), pOutBuf, dwOutputLen))
        {
            //xmlConfigOutput
            CXmlBase xmlBase;
            xmlBase.Parse(pOutBuf);
            if (xmlBase.FindElem("ITDeviceAbility") && xmlBase.IntoElem() && xmlBase.FindElem("ITCAbility"))
            {
                bIsSupportAlarmLevel = TRUE;
                bIsSupportCopilotFace = TRUE;
                if ((xmlBase.IntoElem() && xmlBase.FindElem("TrafficDataUpload")))
                {
                    bIsSupportITSUploadType = TRUE;
                }
            }
        }
    }
    m_cmbAlarmLevel.EnableWindow(bIsSupportAlarmLevel);
    m_cmbITSUploadType.EnableWindow(bIsSupportITSUploadType);
    GetDlgItem(IDC_CHECK_COPILOT_FACE)->EnableWindow(bIsSupportCopilotFace);

    delete []pOutBuf;
    pOutBuf = NULL;
}

/////////////////////////////////////////////////////////////////////////////
/*********************************************************
Function:  CheckEventAbility
Desc:      Get the EventAbility ability based on the DevieceIndex
maximize the alarm ability(one channel supports means all channel support)
Input:     none
Output:    none
Return:    none
**********************************************************/
void CAlarmAdvanceSetter::CheckEventAbility()
{
    //ѯEventAbility
    /*Ϣ-:1.ӿڵóɹ2.ж<EventAbility>е<FaceDetection>ڵڣʾ豸֧֡⡱*/

    DWORD dwAbilityType = DEVICE_ABILITY_INFO;
    char pInBuf[512] = "";
    DWORD dwOutputLen = 1024 * 1024;
    char *pOutBuf = new char[dwOutputLen];

    for (int iChannelindex = 0; iChannelindex < g_struDeviceInfo[m_iDeviceIndex].iDeviceChanNum; iChannelindex++)
    {
        if (g_struDeviceInfo[m_iDeviceIndex].pStruChanInfo[iChannelindex].bEnable == FALSE)
        {
            continue;
        }
        sprintf(pInBuf, "<EventAbility version=\"2.0\">\r\n<channelNO>%d</channelNO>\r\n</EventAbility>", iChannelindex + 1);
        memset(pOutBuf, 0, dwOutputLen);
        if (NET_DVR_GetDeviceAbility(g_struDeviceInfo[m_iDeviceIndex].lLoginID, dwAbilityType, pInBuf, strlen(pInBuf), pOutBuf, dwOutputLen))
        {
            CXmlBase xmlBase;
            xmlBase.Parse(pOutBuf);

            if (xmlBase.FindElem("EventAbility") && xmlBase.IntoElem() && xmlBase.FindElem("FaceDetection"))
            {
                m_bIsSupportFaceDetection = TRUE;
                return;
            }
        }
    }

    delete[]pOutBuf;
    pOutBuf = NULL;
}


/////////////////////////////////////////////////////////////////////////////
/*********************************************************
Function:  CheckVcaChanAbility
Desc:      Get the VcaChanAbility ability based on the DevieceIndex
maximize the alarm ability(one channel supports means all channel support)
Input:     none
Output:    none
Return:    none
**********************************************************/
void CAlarmAdvanceSetter::CheckVcaChanAbility()
{
    //ѯVcaChanAbility 
    /*Ϣ-ץ: 1.ӿڵóɹ2.ж<VcaChanAbility>е<Face>е<FaceSnap>ڵڣʾ豸֧֡ץġ
      ץ1.ӿڵóɹ2.ж<VcaChanAbility>е<Face>е<FaceSnap>е<brokenNetHttp>ڵڣʾ豸֧֡ץĶ */
    DWORD dwAbilityType = DEVICE_ABILITY_INFO;
    char pInBuf[512] = "";
    DWORD dwOutputLen = 1024 * 1024;
    char *pOutBuf = new char[dwOutputLen];

    BOOL bIsSupportFaceSnapBroken = FALSE;

    for (int iChannelindex = 0; iChannelindex < g_struDeviceInfo[m_iDeviceIndex].iDeviceChanNum; iChannelindex++)
    {
        if (g_struDeviceInfo[m_iDeviceIndex].pStruChanInfo[iChannelindex].bEnable == FALSE)
        {
            continue;
        }
        sprintf(pInBuf, "<VcaChanAbility version=\"2.0\">\r\n<channelNO>%d</channelNO>\r\n</VcaChanAbility>", iChannelindex + 1);
        memset(pOutBuf, 0, dwOutputLen);
        if (NET_DVR_GetDeviceAbility(g_struDeviceInfo[m_iDeviceIndex].lLoginID, dwAbilityType, pInBuf, strlen(pInBuf), pOutBuf, dwOutputLen))
        {
            CXmlBase xmlBase;
            xmlBase.Parse(pOutBuf);

            if (xmlBase.FindElem("VcaChanAbility") && xmlBase.IntoElem() && xmlBase.FindElem("Face") && xmlBase.IntoElem() && xmlBase.FindElem("FaceSnap"))
            {
                m_bIsSupportFaceSnap = TRUE;
                //2.ץĶ
                if ((xmlBase.IntoElem() && xmlBase.FindElem("brokenNetHttp")))
                {
                    bIsSupportFaceSnapBroken = TRUE;
                }
            }
        }
    }

    GetDlgItem(IDC_CHECK_FACE_SNAP_BROKEN)->EnableWindow(bIsSupportFaceSnapBroken);
    delete []pOutBuf;
    pOutBuf = NULL;
    
}

/////////////////////////////////////////////////////////////////////////////
/*********************************************************
Function:  CheckBasicCapability
Desc:      Get the BasicCapability ability based on the DevieceIndex
maximize the alarm ability(one channel supports means all channel support)
Input:     none
Output:    none
Return:    none
**********************************************************/
void CAlarmAdvanceSetter::CheckBasicCapability()
{
    //ѯ: 1.ƣȶͼ,JSON͸IPC
    /*ƣȶͼ: 1.ӿڵóɹ2.ж<BasicCapability>е<SoftwareCapability>е<BrokenNetHttpSupport>ڵڣʾֶ֧ƣ
        ͬʱԹ 
        postMPR - Ƽ
        PDC - ͳ
        heatMapDetection - ȶͼ
    JSON͸IPC:1.ӿڵóɹ2.ж<BasicCapability>е<SoftwareCapability>е<isSupportAlarmJSONBrokenNetHttp>Ƿڣھͱʾ֧֣
    */
    

    DWORD dwAbilityType = DEVICE_SOFTHARDWARE_ABILITY;
    char pInBuf[512] = "";
    DWORD dwOutputLen = 1024 * 1024;
    char *pOutBuf = new char[dwOutputLen];
    memset(pOutBuf, 0, dwOutputLen);

    BOOL bIsSupportChePaiBroken = FALSE;
    BOOL bIsSupportKeLiuTongJiBroken = FALSE;
    BOOL bIsSupportHotMapBroken = FALSE;
    BOOL bIsSupportJsonBroken = FALSE;
    BOOL bIsSupportConfirmMechanism = FALSE;

    BOOL bIsSupportAIDBroken = FALSE;
    BOOL bIsSupportTFSBroken = FALSE;
    BOOL bIsSupportTPSStatBroken = FALSE;
    if (NET_DVR_GetDeviceAbility(g_struDeviceInfo[m_iDeviceIndex].lLoginID, dwAbilityType, NULL, 0, pOutBuf, dwOutputLen))
    {
        CXmlBase xmlBase;
        xmlBase.Parse(pOutBuf);

        if (xmlBase.FindElem("BasicCapability") && xmlBase.IntoElem() && xmlBase.FindElem("SoftwareCapability") && xmlBase.IntoElem())
        {
            if (xmlBase.FindElem("BrokenNetHttpSupport"))
            {
                string sOpt = xmlBase.GetAttributeValue("opt");
                if (sOpt.find("postMPR") != string::npos)
                {
                    bIsSupportChePaiBroken = TRUE;
                }
                if (sOpt.find("PDC") != string::npos)
                {
                    bIsSupportKeLiuTongJiBroken = TRUE;
                }
                if (sOpt.find("heatMapDetection") != string::npos)
                {
                    bIsSupportHotMapBroken = TRUE;
                }
            }

            if (xmlBase.FindElem("isSupportConfirmMechanism"))
            {
                //ȷϻ
                bIsSupportConfirmMechanism = TRUE;
            }

            if (xmlBase.FindElem("isSupportAlarmJSONBrokenNetHttp"))
            {
                //JSON͸IPC
                bIsSupportJsonBroken = TRUE;
            }

            if (xmlBase.FindElem("isSupportAIDAlarmBrokenNetHttp"))
            {
                //AID
                bIsSupportAIDBroken = TRUE;
            }

            if (xmlBase.FindElem("isSupportAlarmJSONBrokenNetHttp"))
            {
                //TFS
                bIsSupportTFSBroken = TRUE;
            }

            if (xmlBase.FindElem("isSupportTPSStatisticsAlarmBrokenNetHttp"))
            {
                //TPSͳƹ¼
                bIsSupportTPSStatBroken = TRUE;
            }

            if (xmlBase.FindElem("isSupportBehaviorUploadByCloudStorageURL"))
            {
                //Ƿ֧֧Ϊ¼ͨ人urlϱ
                m_bIsSupportBehaviorUploadByCloudStorageURL = TRUE;
            }
        }
    }
    GetDlgItem(IDC_CHECK_CHEPAI_BROKEN)->EnableWindow(bIsSupportChePaiBroken);
    GetDlgItem(IDC_CHECK_KELIUTONGJI_BROKEN)->EnableWindow(bIsSupportKeLiuTongJiBroken);
    GetDlgItem(IDC_CHECK_HotMap_BROKEN)->EnableWindow(bIsSupportHotMapBroken);
    GetDlgItem(IDC_CHECK_JSON_PASS)->EnableWindow(bIsSupportJsonBroken);
    GetDlgItem(IDC_CHECK_CONFIRM_MECHANISM)->EnableWindow(bIsSupportConfirmMechanism);

    GetDlgItem(IDC_CHECK_AID_BROKEN)->EnableWindow(bIsSupportAIDBroken);
    GetDlgItem(IDC_CHECK_TFS_BROKEN)->EnableWindow(bIsSupportTFSBroken);
    GetDlgItem(IDC_CHECK_TPS_STATISTIC_BROKEN)->EnableWindow(bIsSupportTPSStatBroken);

    delete []pOutBuf;
    pOutBuf = NULL;
}

/////////////////////////////////////////////////////////////////////////////
/*********************************************************
Function:  CheckFaceContrast
Desc:      Get the FaceContrast Broken Upload ability based on the DevieceIndex
maximize the alarm ability(one channel supports means all channel support)
Input:     none
Output:    none
Return:    none
**********************************************************/
void CAlarmAdvanceSetter::CheckFaceContrast()
{
    //ѯԱȶ
    /*
    1.ӿڵóɹ
    2.ж<FaceContrastCap>е<brokenNetHttp>ڵڱʾ֧
    */
    NET_DVR_XML_CONFIG_INPUT  xmlConfigInput = { 0 };
    NET_DVR_XML_CONFIG_OUTPUT  xmlCongfigOutput = { 0 };
    xmlConfigInput.dwSize = sizeof(xmlConfigInput);
    xmlCongfigOutput.dwSize = sizeof(xmlCongfigOutput);

    char szUrl[256] = ""; 
    DWORD dwOutputLen = 1024 * 1024;
    char *pOutBuf = new char[dwOutputLen];

    BOOL bIsSupportFaceMatchBroken = FALSE;

    for (int iChannelindex = 0; iChannelindex < g_struDeviceInfo[m_iDeviceIndex].iDeviceChanNum; iChannelindex++)
    {
        if (g_struDeviceInfo[m_iDeviceIndex].pStruChanInfo[iChannelindex].bEnable == FALSE)
        {
            continue;
        }
        sprintf(szUrl, "GET /ISAPI/Intelligent/channels/%d/faceContrast/capabilities", iChannelindex + 1);
        xmlConfigInput.lpRequestUrl = szUrl;
        xmlConfigInput.dwRequestUrlLen = strlen(szUrl);

        memset(pOutBuf, 0, dwOutputLen);
        xmlCongfigOutput.dwOutBufferSize = dwOutputLen;
        xmlCongfigOutput.lpOutBuffer = pOutBuf;

        if (NET_DVR_STDXMLConfig(g_struDeviceInfo[m_iDeviceIndex].lLoginID, &xmlConfigInput, &xmlCongfigOutput))
        {
            CXmlBase xmlBase;
            xmlBase.Parse(pOutBuf);

            if ((xmlBase.FindElem("FaceContrastCap") && xmlBase.IntoElem() && xmlBase.FindElem("brokenNetHttp")))
            {
                bIsSupportFaceMatchBroken = TRUE;
            }
        }
    }
    GetDlgItem(IDC_CHECK_FACE_MATCH_BROKEN)->EnableWindow(bIsSupportFaceMatchBroken);
    delete []pOutBuf;
    pOutBuf = NULL;
}

/////////////////////////////////////////////////////////////////////////////
/*********************************************************
Function:  CheckVehicleRecogAbility
Desc:      Get the VehicleRecogAbility ability based on the DevieceIndex
maximize the alarm ability(one channel supports means all channel support)
Input:     none
Output:    none
Return:    none
**********************************************************/
void CAlarmAdvanceSetter::CheckVehicleRecogAbility()
{
    //ѯVehicleRecogAbility  
    /*:1.ӿڵóɹ2.ж<VehicleRecogAbility>е<taskNo>Ƿڣھͱʾ֧
    */
    DWORD dwAbilityType = DEVICE_ABILITY_INFO;
    char pInBuf[512] = "";
    DWORD dwOutputLen = 1024 * 1024;
    char *pOutBuf = new char[dwOutputLen];

    BOOL bIsSupportTaskNum = FALSE;

    for (int iChannelindex = 0; iChannelindex < g_struDeviceInfo[m_iDeviceIndex].iDeviceChanNum; iChannelindex++)
    {
        if (g_struDeviceInfo[m_iDeviceIndex].pStruChanInfo[iChannelindex].bEnable == FALSE)
        {
            continue;
        }
        sprintf(pInBuf, "<VehicleRecogAbility version=\"2.0\">\r\n<channelNO>%d</channelNO>\r\n</VehicleRecogAbility>", iChannelindex + 1);
        memset(pOutBuf, 0, dwOutputLen);
        if (NET_DVR_GetDeviceAbility(g_struDeviceInfo[m_iDeviceIndex].lLoginID, dwAbilityType, pInBuf, strlen(pInBuf), pOutBuf, dwOutputLen))
        {
            CXmlBase xmlBase;
            xmlBase.Parse(pOutBuf);

            if ((xmlBase.FindElem("VehicleRecogAbility") && xmlBase.IntoElem() && xmlBase.FindElem("taskNo")))
            {
                bIsSupportTaskNum = TRUE;
            }
        }
    }
    GetDlgItem(IDC_EDIT_TASK_NUMBER)->EnableWindow(bIsSupportTaskNum);
    delete[]pOutBuf;
    pOutBuf = NULL;

}

/////////////////////////////////////////////////////////////////////////////
/*********************************************************
Function:  CheckVehicleRecogAbility
Desc:      Get the VehicleRecogAbility ability based on the DevieceIndex
maximize the alarm ability(one channel supports means all channel support)
Input:     none
Output:    none
Return:    none
**********************************************************/
void CAlarmAdvanceSetter::CheckCloudStorageCfg()
{
    //ͼƬ
    /*1ӿڵóɹ2жbyEnable Ƿ 11Ǿ˵豸֧ƴ洢ƴ洢ѾĬеURIƴ洢ʽ
    ʱʾѡ0-ƴ䣻1-URL䣩
    */
    DWORD dwCommand = NET_DVR_GET_CLOUDSTORAGE_CFG;
    DWORD dwCount = 1;
    NET_DVR_CLOUDSTORAGE_COND struStorageCond = { 0 };
    struStorageCond.dwSize = sizeof(struStorageCond);
    struStorageCond.dwChannel = 1;
    NET_DVR_CLOUDSTORAGE_CFG struStorageCfg = { 0 };
    DWORD dwStatusList = 0;

    BOOL bIsSupportCloudStorage = FALSE;

    if (NET_DVR_GetDeviceConfig(g_struDeviceInfo[m_iDeviceIndex].lLoginID, dwCommand, dwCount, \
        &struStorageCond, sizeof(NET_DVR_CLOUDSTORAGE_COND), &dwStatusList, &struStorageCfg, sizeof(NET_DVR_CLOUDSTORAGE_CFG)))
    {
        if (struStorageCfg.byEnable == 1)
        {
            //֧urlֱӷ
            bIsSupportCloudStorage = TRUE;
            GetDlgItem(IDC_COMBO_FACE_SNAP_DATA_TYPE)->EnableWindow(bIsSupportCloudStorage);
            GetDlgItem(IDC_COMBO_FACE_MATCH_DATA_TYPE)->EnableWindow(bIsSupportCloudStorage);
            GetDlgItem(IDC_COMBO_EVENT_JSON_DATA_TYPE)->EnableWindow(bIsSupportCloudStorage);
            if (m_bIsSupportBehaviorUploadByCloudStorageURL)//Ƿ֧֧Ϊ¼ͨ人urlϱ
            {
                GetDlgItem(IDC_COMBO_BEHAVIOR)->EnableWindow(bIsSupportCloudStorage);
            }
            else
            {
                GetDlgItem(IDC_COMBO_BEHAVIOR)->EnableWindow(FALSE);
            }
            return;
        }
    }

    //ƴ洢2.0isapi͸Эж
    char szUrl[512] = "";
    sprintf(szUrl, "GET /ISAPI/ContentMgmt/channels/1/cloudStorage/1");
    DWORD dwOutputLen = 1024 * 1024 * 3 ;
    char *pOutBuf = new char[dwOutputLen];
    if (NULL == pOutBuf)
    {
        AfxMessageBox("Apply Memory Failed!\n");
        return;
    }
    memset(pOutBuf, 0, dwOutputLen);
    NET_DVR_XML_CONFIG_INPUT struXmlCfgIn = { 0 };
    struXmlCfgIn.dwSize = sizeof(struXmlCfgIn);
    struXmlCfgIn.lpRequestUrl = szUrl;
    struXmlCfgIn.dwRequestUrlLen = strlen(szUrl);

    NET_DVR_XML_CONFIG_OUTPUT struXmlCfgOut = { 0 };
    struXmlCfgOut.dwSize = sizeof(struXmlCfgOut);
    struXmlCfgOut.lpOutBuffer = pOutBuf;
    struXmlCfgOut.dwOutBufferSize = dwOutputLen;

    if (NET_DVR_STDXMLConfig(g_struDeviceInfo[m_iDeviceIndex].lLoginID, &struXmlCfgIn, &struXmlCfgOut))
    {
        CXmlBase xmlBase;
        xmlBase.Parse(pOutBuf);
        if (xmlBase.FindElem("CloudStorage") && xmlBase.IntoElem())
        {
            //CloudStorage->enable
            if (xmlBase.FindElem("enable") && xmlBase.GetData() == "true")
            {
                bIsSupportCloudStorage = TRUE;
            }
            //CloudStorage->V2.0->enabled
            if (!bIsSupportCloudStorage && xmlBase.FindElem("V2.0") && xmlBase.IntoElem())
            {
                if (  xmlBase.FindElem("enabled") && xmlBase.GetData() == "true")
                {
                    bIsSupportCloudStorage = TRUE;
                }
                else 
                {
                    xmlBase.OutOfElem();
                }
            }
            //CloudStorage->ImageAndVideoCloud->enabled
            if (!bIsSupportCloudStorage && xmlBase.FindElem("ImageAndVideoCloud") && xmlBase.IntoElem())
            {
                if(xmlBase.FindElem("enabled") && xmlBase.GetData() == "true")
                {
                    bIsSupportCloudStorage = TRUE;
                }
            }
        }
    }
    //ڵ
    //else
    //{
    //    char szErrorMsg[512]= { 0 };
    //    sprintf(szErrorMsg,"ErrrorCode:%d .\n Error Msg: %s.", (char*)NET_DVR_GetLastError(), NET_DVR_GetErrorMsg());
    //    MessageBox(szErrorMsg);
    //}
    GetDlgItem(IDC_COMBO_FACE_SNAP_DATA_TYPE)->EnableWindow(bIsSupportCloudStorage);
    GetDlgItem(IDC_COMBO_FACE_MATCH_DATA_TYPE)->EnableWindow(bIsSupportCloudStorage);
    GetDlgItem(IDC_COMBO_EVENT_JSON_DATA_TYPE)->EnableWindow(bIsSupportCloudStorage);
    if (m_bIsSupportBehaviorUploadByCloudStorageURL)//Ƿ֧֧Ϊ¼ͨ人urlϱ
    {
        GetDlgItem(IDC_COMBO_BEHAVIOR)->EnableWindow(bIsSupportCloudStorage);
    }
    else
    {
        GetDlgItem(IDC_COMBO_BEHAVIOR)->EnableWindow(FALSE);
    }

    if (pOutBuf != NULL)
    {
        delete[] pOutBuf;
        pOutBuf = NULL;
    }
}

/////////////////////////////////////////////////////////////////////////////
/*********************************************************
Function:  setDeviceAbility
Desc:      Get the alarm ability (ITDeviceAbility, EventAbility, VcaChanAbility, VehicleRecogAbility and so on) based on the DevieceIndex
           maximize the alarm ability(one channel supports means all channel support)
Input:     none
Output:    none
Return:    none
**********************************************************/
BOOL CAlarmAdvanceSetter::setDeviceAbility()
{
   
    //check that whether the device supports AlarmLevel, ITSUploadType, Copilot Face ability
    CheckITDeviceAbility();

    //check that whether the device supports FaceDetectionType:FaceDetection ability
    CheckEventAbility();  
  
    //check that whether the device supports FaceDetectionType:FaceSnaphot ability
    CheckVcaChanAbility();  


    //To Judge the FaceDetectionType
    if (m_bIsSupportFaceSnap && m_bIsSupportFaceDetection)
    {
        m_cmbFaceDetectType.EnableWindow(TRUE);
    }
    else if (m_bIsSupportFaceSnap)
    {
        m_cmbFaceDetectType.SetCurSel(0);
        m_cmbFaceDetectType.EnableWindow(FALSE);
    }
    else
    {
        m_cmbFaceDetectType.SetCurSel(1);
        m_cmbFaceDetectType.EnableWindow(FALSE);
    }

    /*//ȷϻ ⣬Զͨȡ豸жȷϻǷſ
    if (!(g_struDeviceInfo[m_iDeviceIndex].bySupport2 & 0x08 == 1))
    {
        GetDlgItem(IDC_CHECK_CONFIRM_MECHANISM)->EnableWindow(FALSE);

    }*/
    //֧Щͣȷϻ
    CheckBasicCapability();

    //Ƿ֧Աȶ
    CheckFaceContrast();

    //Ƿ֧
    CheckVehicleRecogAbility();

    //ͼƬݴ洢
    CheckCloudStorageCfg();



    ////ѯVideoPicAbility
    //dwAbilityType = DEVICE_VIDEOPIC_ABILITY;
    //sprintf(pInBuf, "<VideoPicAbility version=\"2.0\">\r\n<channelNO>1</channelNO>\r\n</VideoPicAbility>");
    //memset(pOutBuf, 0, dwOutputLen);

    //if (NET_DVR_GetDeviceAbility(g_struDeviceInfo[m_iDeviceIndex].lLoginID, dwAbilityType, pInBuf, strlen(pInBuf), pOutBuf, dwOutputLen))
    //{
    //    CXmlBase xmlBase;
    //    xmlBase.Parse(pOutBuf);

    //    if (xmlBase.FindElem("VideoPicAbility") && xmlBase.IntoElem() && xmlBase.FindElem("MotionDetection"))
    //    {
    //        m_bIsSupportAlarmTypeV40 = TRUE;
    //    }
    //}

    return TRUE;
}

//ѡϢͣALL  LIST
void CAlarmAdvanceSetter::OnCbnSelchangeComboAlarmSubscribeInfo()
{
    CString csSelect = "";
    m_cmbAlarmSubscribeInfo.GetLBText(m_cmbAlarmSubscribeInfo.GetCurSel(), csSelect);
    if (m_cmbAlarmSubscribeInfo.GetCurSel() == 0)  //ALL
    {
        //еLISTѡ
        SetSubscribeItemsEnabled(FALSE);
    }
    else if (m_cmbAlarmSubscribeInfo.GetCurSel() == 1) //LIST
    {
        //еLISTѡ
        SetSubscribeItemsEnabled(TRUE);
    }
    else
    {
        char szLan[1024] = { 0 };
        g_StringLanType(szLan, "δѡжϢ", "Pick the Subscription Type!");
        AfxMessageBox(szLan);
    }
}

/////////////////////////////////////////////////////////////////////////////
/*********************************************************
Function:  SetSubscribeItemsEnabled
Desc:      Change the subscribe check box state 
Input:     enabled(the state of subscribe check box)
Output:    none
Return:    none
**********************************************************/
void CAlarmAdvanceSetter::SetSubscribeItemsEnabled(BOOL enabled)
{
    //GetDlgItem(IDC_STATIC_LIST_SUBSCRIBE_LIST)->EnableWindow(enabled);
    GetDlgItem(IDC_COMBO_EVENT_TYPE)->EnableWindow(enabled);
    GetDlgItem(IDC_LIST_EVENT_PARAM)->EnableWindow(enabled);
    GetDlgItem(IDC_BUTTON_ADD_PARAM)->EnableWindow(enabled);
    GetDlgItem(IDC_BUTTON_DELETE)->EnableWindow(enabled);
}

/////////////////////////////////////////////////////////////////////////////
/*********************************************************
Function:  OnBnClickedButtonConfirm
Desc:      Save the AlarmParam to m_pStruSetupAlarmParamV50
Input:     none
Output:    none
Return:    none
**********************************************************/
void CAlarmAdvanceSetter::OnBnClickedButtonConfirm()
{
    // TODO:  ڴӿؼ֪ͨ
    UpdateData(TRUE);
    GenerateSubcribeParam();
    m_pStruSetupAlarmParamV50->dwSize = sizeof(NET_DVR_SETUPALARM_PARAM_V50);

    m_pStruSetupAlarmParamV50->byLevel = m_cmbAlarmLevel.GetCurSel();
    m_pStruSetupAlarmParamV50->byCustomCtrl = m_bCopilotFace;

    m_pStruSetupAlarmParamV50->byAlarmInfoType = m_cmbITSUploadType.GetCurSel();

    m_pStruSetupAlarmParamV50->byRetAlarmTypeV40 = TRUE;
    m_pStruSetupAlarmParamV50->byRetDevInfoVersion = TRUE;  //CVRϴϢ(ԽCVRʱЧ)
    m_pStruSetupAlarmParamV50->byRetVQDAlarmType = TRUE; //Prefer VQD Alarm type of NET_DVR_VQD_ALARM

    //m_bIsSupportFaceSnap       m_bIsSupportFaceDetection = FALSE;
    m_pStruSetupAlarmParamV50->byFaceAlarmDetection = m_cmbFaceDetectType.GetCurSel();

    m_pStruSetupAlarmParamV50->bySupport = 0;
    m_pStruSetupAlarmParamV50->bySupport |= (m_bConfirmMechanism << 1); //
    m_pStruSetupAlarmParamV50->bySupport |= (1 << 2);

    m_pStruSetupAlarmParamV50->byBrokenNetHttp = 0;
    m_pStruSetupAlarmParamV50->byBrokenNetHttp |= (m_bChePaiBroken << 0);
    m_pStruSetupAlarmParamV50->byBrokenNetHttp |= (m_bKeLiuTongJiBroken << 1);
    m_pStruSetupAlarmParamV50->byBrokenNetHttp |= (m_bHotMapBroken << 2);
    m_pStruSetupAlarmParamV50->byBrokenNetHttp |= (m_bFaceSanpBroken << 3);
    m_pStruSetupAlarmParamV50->byBrokenNetHttp |= (m_bFaceMatchBroken << 4);
    m_pStruSetupAlarmParamV50->byBrokenNetHttp |= (m_bJsonPass << 5);
    m_pStruSetupAlarmParamV50->byBrokenNetHttp |= (m_bChkHeatMapDurationPDC << 6);
    m_pStruSetupAlarmParamV50->byBrokenNetHttp |= (m_bChkHeatMapIntersection << 7);

    m_pStruSetupAlarmParamV50->wTaskNo = m_iTaskNo;

    m_pStruSetupAlarmParamV50->byDeployType = m_cmbAlarmType.GetCurSel();

    if (m_bRetAlarmTypeV40 == TRUE) // ָV40
    {
        m_pStruSetupAlarmParamV50->byRetAlarmTypeV40 = FALSE;
    }

    if (m_bNVRAlarmIPC == TRUE)  // NVRȫIPC
    {
        m_pStruSetupAlarmParamV50->bySupport |= 0x10;
    }

    if (m_bVMDPic == TRUE) // ƶ˳ഫͼ
    {
        m_pStruSetupAlarmParamV50->bySubScription |= 0x80;
    }

    //ϴͼƬURL߶
    m_pStruSetupAlarmParamV50->byAlarmTypeURL = 0;
    m_pStruSetupAlarmParamV50->byAlarmTypeURL |= (m_cmbFaceSnapDataType.GetCurSel() << 0);
    m_pStruSetupAlarmParamV50->byAlarmTypeURL |= (m_cmbEventJsonDataType.GetCurSel() << 1);
    m_pStruSetupAlarmParamV50->byAlarmTypeURL |= (m_cmbFaceMatchDataType.GetCurSel() << 2);
    m_pStruSetupAlarmParamV50->byAlarmTypeURL |= (m_cmbBehavior.GetCurSel() << 3);


    if (m_bEnableXml)
    {
        strncpy(m_pData, m_pSub, MAX_SUBSCRIBE_DATA_LENGTH);
    }
    else
    {
        strcpy(m_pData, m_strSubscribe.GetBuffer());
    }

    m_pStruSetupAlarmParamV50->byBrokenNetHttpV60 = 0;
    m_pStruSetupAlarmParamV50->byBrokenNetHttpV60 |= (m_bAidBroken << 0);
    m_pStruSetupAlarmParamV50->byBrokenNetHttpV60 |= (m_bTfsBroken << 1);
    m_pStruSetupAlarmParamV50->byBrokenNetHttpV60 |= (m_bTPsStatBroken << 2);
    //HWND hParentHnd = ::FindWindow(NULL, _T("/"));
    //::SendMessage(hParentHnd, WM_ALARM_ADVANCED_SETTER, (DWORD)&struSetupAlarmParamV50, (LONG)&szData);
    OnCancel();

}

/////////////////////////////////////////////////////////////////////////////
/*********************************************************
Function:    setAdvanceAlarmParam
Desc:        Save the pointer of AlarmParam to m_pStruSetupAlarmParamV50
Input:    pStruSetupAlarmParamV50: the pointer of AlarmParam
          pData: the pointer of subscribe info data
Output:    none
Return:    none
**********************************************************/
void CAlarmAdvanceSetter::setAdvanceAlarmParam(NET_DVR_SETUPALARM_PARAM_V50* pStruSetupAlarmParamV50,char *pData)
{
    m_pStruSetupAlarmParamV50 = pStruSetupAlarmParamV50;
    m_pData = pData;
}


void CAlarmAdvanceSetter::OnBnClickedBtnXmlsub()
{
    // TODO:  ڴӿؼ֪ͨ
    m_DlgXmlSub.getXmlSub(m_pSub);
    m_DlgXmlSub.DoModal();
}

/** @fn void CAlarmAdvanceSetter::UpdateChanStatus()
 *  @brief ͨб
 *  @return void
 */

void CAlarmAdvanceSetter::UpdateChanStatus()
{
    int iIndex = 0;
    int i = 0;
    CString csTemp;
    m_listChan.DeleteAllItems();
    //get the whole state of all channels

    if (m_iDeviceIndex < 0)
    {
        return;
    }

    for (i = 0; i < g_struDeviceInfo[m_iDeviceIndex].iDeviceChanNum; i++)
    {
        if (i < g_struDeviceInfo[m_iDeviceIndex].iAnalogChanNum)
        {
            csTemp.Format(ANALOG_C_FORMAT, g_struDeviceInfo[m_iDeviceIndex].iStartChan + i);
            m_listChan.InsertItem(iIndex, csTemp);
            m_listChan.SetItemData(iIndex, i + g_struDeviceInfo[m_iDeviceIndex].iStartChan);
            iIndex++;
        }
        else
        {
            csTemp.Format(DIGITAL_C_FORMAT, i + 1 - g_struDeviceInfo[m_iDeviceIndex].iAnalogChanNum/*g_struDeviceInfo[m_iDeviceIndex].iStartChan-g_struDeviceInfo[m_iDeviceIndex].pStruIPParaCfgV40[0].dwStartDChan*/);
            m_listChan.InsertItem(iIndex, csTemp);
            m_listChan.SetItemData(iIndex, i - g_struDeviceInfo[m_iDeviceIndex].iAnalogChanNum + g_struDeviceInfo[m_iDeviceIndex].pStruIPParaCfgV40[0].dwStartDChan);
            iIndex++;
        }
    }
}

/** @fn void CAlarmAdvanceSetter::OnBnClickedButtonGetSubscribe()
 *  @brief ȡĲ
 *  @return void
 */

void CAlarmAdvanceSetter::OnBnClickedButtonGetSubscribe()
{
    // TODO:  ڴӿؼ֪ͨ
    UpdateData(TRUE);
    if (m_iDeviceIndex < 0)
    {
        return;
    }

    DWORD dwOutputLen = 1024 * 1024;
    char *pOutBuf = new char[dwOutputLen];
    memset(pOutBuf, 0, dwOutputLen);

    if (NET_DVR_GetAlarmSubscribe(g_struDeviceInfo[m_iDeviceIndex].lFortifyHandle, pOutBuf, dwOutputLen))
    {
        m_strSubscribe = pOutBuf;
        GenerateSubcribeListData();
        g_pMainDlg->AddLog(m_iDeviceIndex, OPERATION_SUCC_T, "NET_DVR_GetAlarmSubscribe");
    }
    else
    {
        g_pMainDlg->AddLog(m_iDeviceIndex, OPERATION_FAIL_T, "NET_DVR_GetAlarmSubscribe");
    }

    if (pOutBuf != NULL)
    {
        delete[]pOutBuf;
        pOutBuf = NULL;
    }
    UpdateData(FALSE);
}


/** @fn void CAlarmAdvanceSetter::OnBnClickedButtonSetSubscribe()
 *  @brief öĲ
 *  @return void
 */

void CAlarmAdvanceSetter::OnBnClickedButtonSetSubscribe()
{
    // TODO:  ڴӿؼ֪ͨ
    UpdateData(TRUE);
    if (m_iDeviceIndex < 0)
    {
        return;
    }

    GenerateSubcribeParam();

    DWORD dwInputLen = m_strSubscribe.GetLength();
    char *pInBuf = m_strSubscribe.GetBuffer();

    if (NET_DVR_SetAlarmSubscribe(g_struDeviceInfo[m_iDeviceIndex].lFortifyHandle, pInBuf, dwInputLen))
    {
        g_pMainDlg->AddLog(m_iDeviceIndex, OPERATION_SUCC_T, "NET_DVR_SetAlarmSubscribe");
    }
    else
    {
        g_pMainDlg->AddLog(m_iDeviceIndex, OPERATION_FAIL_T, "NET_DVR_SetAlarmSubscribe");
    }
    UpdateData(FALSE);
}

/** @fn void CAlarmAdvanceSetter::GetModeAllSubscribeParam(CString & strData)
 *  @brief ȡeventTypeΪallʱĲ
 *  @param (in)	CString & strData    
 *  @return void
 */

void CAlarmAdvanceSetter::GetModeAllSubscribeParam(CString & strData)
{
    CString strTemp = _T("");
    CString strChannels = _T("");
    bool bFirst = true;
    if (m_bChannelEnable)
    {
        CString strParam, strChannel = _T("");
        for (int i = 0; i < m_listChan.GetItemCount(); i++)
        {
            if (m_listChan.GetCheck(i))
            {
                int iChannel = -1;
                iChannel = NET_DVR_SDKChannelToISAPI(g_struDeviceInfo[m_iDeviceIndex].lLoginID, m_listChan.GetItemData(i), TRUE);
                if (bFirst)
                {
                    strChannel.Format("%d", iChannel);
                    bFirst = false;
                }
                else
                {
                    strChannel.Format(",%d", iChannel);
                }
                strParam += strChannel;
            }
        }
        strChannels.Format("%s%s%s", "<channels>", strParam, "</channels>\r\n");
    }

    if (m_comboPictureUrlType.GetCurSel() >= 0)
    {
        m_comboPictureUrlType.GetLBText(m_comboPictureUrlType.GetCurSel(), strTemp);
        strData.Format("%s%s%s%s", strChannels, "<pictureURLType>", strTemp, "</pictureURLType>\r\n");
    }
}

/** @fn void CAlarmAdvanceSetter::GetChangedUploadSubParam(CString & strData)
 *  @brief ȡ仯ϱ
 *  @param (in)	CString & strData    
 *  @return void
 */

void CAlarmAdvanceSetter::GetChangedUploadSubParam(CString & strData)
{
    strData = _T("");
    if (m_bUploadAll)
    {
        strData += "<ChangedUploadSub>\r\n<StatusSub>\r\n<all>true</all>\r\n</StatusSub>\r\n</ChangedUploadSub>";
    }
    else if (m_bUploadChannel || m_bUploadHd || m_bUploadCapability)
    {
        strData += "<ChangedUploadSub>\r\n<StatusSub>\r\n";
        if (m_bUploadChannel)
        {
            strData += "<channel>true</channel>";
        }
        if (m_bUploadHd)
        {
            strData += "<hd>true</hd>";
        }
        if (m_bUploadCapability)
        {
            strData += "<capability>true</capability>";
        }

        strData += "\r\n</StatusSub>\r\n</ChangedUploadSub>";
    }
}

/** @fn void CAlarmAdvanceSetter::InitEventType()
 *  @brief ʼ¼
 *  @return void
 */

void CAlarmAdvanceSetter::InitEventType()
{
    char szLan[128] = { 0 };
    UpdateData(TRUE);
    int iIndex = 0;
    m_comboEventType.ResetContent();
    for (iIndex = 0; iIndex < sizeof(szEventType) / sizeof(char*); iIndex++)
    {
        m_comboEventType.InsertString(iIndex, szEventType[iIndex]);
    }

    m_comboEventType.SetCurSel(0);//ĬΪƶ
    UpdateData(FALSE);
}

/** @fn void CAlarmAdvanceSetter::OnBnClickedButtonAddParam()
 *  @brief Ӷ¼
 *  @return void
 */

void CAlarmAdvanceSetter::OnBnClickedButtonAddParam()
{
    // TODO:  ڴӿؼ֪ͨ
    UpdateData(TRUE);
    int iRowCount = m_listEventParam.GetItemCount();
    CString strTemp = _T("");
    strTemp.Format("%d", iRowCount);
    m_listEventParam.InsertItem(iRowCount, strTemp);//
    strTemp = _T("");
    m_comboEventType.GetLBText(m_comboEventType.GetCurSel(), strTemp);
    m_listEventParam.SetItemText(iRowCount, 1, strTemp);//¼

    bool bFirst = true;
    if (m_bChannelEnable)
    {
        CString strChannel = _T("");
        strTemp = _T("");
        for (int i = 0; i < m_listChan.GetItemCount(); i++)
        {
            if (m_listChan.GetCheck(i))
            {
                int iChannel = -1;
                iChannel = NET_DVR_SDKChannelToISAPI(g_struDeviceInfo[m_iDeviceIndex].lLoginID, m_listChan.GetItemData(i), TRUE);
                if (bFirst)
                {
                    strChannel.Format("%d", iChannel);
                    bFirst = false;
                }
                else
                {
                    strChannel.Format(",%d", iChannel);
                }
                strTemp += strChannel;
            }
        }
        m_listEventParam.SetItemText(iRowCount, 2, strTemp);//ͨ
    }
    else
    {
        m_listEventParam.SetItemText(iRowCount, 2, "all");//ͨ
    }

    if (m_comboPictureUrlType.GetCurSel() >= 0)//ͼƬ
    {
        m_comboPictureUrlType.GetLBText(m_comboPictureUrlType.GetCurSel(), strTemp);
        m_listEventParam.SetItemText(iRowCount, 3, strTemp);
    }

    UpdateData(FALSE);
}

/** @fn void CAlarmAdvanceSetter::OnBnClickedButtonDeleteParam()
 *  @brief ɾжĲ
 *  @return void
 */

void CAlarmAdvanceSetter::OnBnClickedButtonDeleteParam()
{
    // TODO:  ڴӿؼ֪ͨ
    UpdateData(TRUE);
    m_iRowCount = m_listEventParam.GetItemCount();
    if (m_iLastItem >= 0 && m_iLastItem < m_iRowCount)
    {
        m_listEventParam.DeleteItem(m_iLastItem);
    }
    UpdateData(FALSE);
}

/** @fn void CAlarmAdvanceSetter::OnNMClickListEventParam(NMHDR *pNMHDR, LRESULT *pResult)
 *  @brief 񵥻¼
 *  @param (in)	NMHDR * pNMHDR    
 *  @param (in)	LRESULT * pResult    
 *  @return void
 */

void CAlarmAdvanceSetter::OnNMClickListEventParam(NMHDR *pNMHDR, LRESULT *pResult)
{
    LPNMITEMACTIVATE pNMItemActivate = reinterpret_cast<LPNMITEMACTIVATE>(pNMHDR);
    // TODO:  ڴӿؼ֪ͨ
    m_iLastItem = pNMItemActivate->iItem;
    m_iSubItem = pNMItemActivate->iSubItem;
    //m_bSelectItem = TRUE;

    *pResult = 0;
}

/** @fn void CAlarmAdvanceSetter::GenerateSubcribeParam()
 *  @brief ݿؼɶı
 *  @return void
 */

void CAlarmAdvanceSetter::GenerateSubcribeParam()
{
    UpdateData(TRUE);
    int iIndex = 0;
    char szData[MAX_SUBSCRIBE_DATA_LENGTH] = { 0 };
    CString strTemp = _T("");
    if (m_cmbAlarmSubscribeInfo.GetCurSel() == 0) //ALL
    {
        m_strSubscribe = "<SubscribeEvent version=\"2.0\" xmlns=\"http://www.isapi.org/ver20/XMLSchema\">\r\n<eventMode>all</eventMode>\r\n";
        GetChangedUploadSubParam(strTemp);
        m_strSubscribe += strTemp;
        GetModeAllSubscribeParam(strTemp);
        m_strSubscribe += strTemp;
        m_strSubscribe += "</SubscribeEvent>";
    }
    else
    {
        m_strSubscribe = "<SubscribeEvent version=\"2.0\" xmlns=\"http://www.isapi.org/ver20/XMLSchema\">\r\n<eventMode>list</eventMode>\r\n<EventList>\r\n";
        for (iIndex = 0; iIndex < m_listEventParam.GetItemCount(); iIndex++)
        {
            sprintf(szData, "%s%s%s%s", szData, "<Event>\r\n<type>", m_listEventParam.GetItemText(iIndex, 1), "</type>\r\n");
            if ("def" != m_listEventParam.GetItemText(iIndex, 3))
            {
                sprintf(szData, "%s%s%s%s", szData, "<pictureURLType>", m_listEventParam.GetItemText(iIndex, 3), "</pictureURLType>\r\n");
            }
            if ("all" != m_listEventParam.GetItemText(iIndex, 2))
            {
                sprintf(szData, "%s%s%s%s", szData, "<channels>", m_listEventParam.GetItemText(iIndex, 2), "</channels>\r\n");
            }
            sprintf(szData, "%s%s", szData, "</Event>\r\n");
        }
        m_strSubscribe += szData;
        m_strSubscribe += "</EventList>\r\n";

        GetChangedUploadSubParam(strTemp);
        m_strSubscribe += strTemp;

        m_strSubscribe += "</SubscribeEvent>";
    }
}

/** @fn void CAlarmAdvanceSetter::GenerateSubcribeListData()
 *  @brief ıʾؼ
 *  @return void
 */

void CAlarmAdvanceSetter::GenerateSubcribeListData()
{
    m_listEventParam.DeleteAllItems();
    int iIndex = 0;

    CString csTemp;
    CXmlBase xmlBase;
    xmlBase.Parse(m_strSubscribe.GetBuffer(0));

    m_bUploadAll = FALSE;
    m_bUploadChannel = FALSE;
    m_bUploadHd = FALSE;
    m_bUploadCapability = FALSE;

    if (xmlBase.FindElem("SubscribeEvent") && xmlBase.IntoElem())
    {
        if (xmlBase.FindElem("eventMode") && "list" == xmlBase.GetData())
        {
            m_cmbAlarmSubscribeInfo.SetCurSel(1);
            OnCbnSelchangeComboAlarmSubscribeInfo();
            if (xmlBase.FindElem("EventList") && xmlBase.IntoElem())
            {
                do
                {
                    if (xmlBase.FindElem("Event") && xmlBase.IntoElem())
                    {
                        if (xmlBase.FindElem("type"))
                        {
                            csTemp.Format("%d", iIndex);
                            m_listEventParam.InsertItem(iIndex, csTemp);

                            csTemp.Format("%s", xmlBase.GetData().c_str());
                            m_listEventParam.SetItemText(iIndex, 1, csTemp);

                            if (xmlBase.FindElem("pictureURLType"))
                            {
                                csTemp.Format("%s", xmlBase.GetData().c_str());
                                m_listEventParam.SetItemText(iIndex, 3, csTemp);
                            }
                            else
                            {
                                m_listEventParam.SetItemText(iIndex, 3, "def");
                            }

                            if (xmlBase.FindElem("channels"))
                            {
                                csTemp.Format("%s", xmlBase.GetData().c_str());
                                m_listEventParam.SetItemText(iIndex, 2, csTemp);
                            }
                            else
                            {
                                m_listEventParam.SetItemText(iIndex, 2, "all");
                            }

                            iIndex++;
                        }
                        xmlBase.OutOfElem();
                    }
                } while (xmlBase.NextSibElem());

                xmlBase.OutOfElem();
            }
            if (xmlBase.FindElem("ChangedUploadSub") && xmlBase.IntoElem())
            {
                if (xmlBase.FindElem("StatusSub") && xmlBase.IntoElem())
                {
                    if (xmlBase.FindElem("all") && "true" == xmlBase.GetData())
                    {
                        m_bUploadAll = TRUE;
                    }
                    else
                    {
                        m_bUploadAll = FALSE;
                    }

                    if (xmlBase.FindElem("channel") && "true" == xmlBase.GetData())
                    {
                        m_bUploadChannel = TRUE;
                    }
                    else
                    {
                        m_bUploadChannel = FALSE;
                    }

                    if (xmlBase.FindElem("hd") && "true" == xmlBase.GetData())
                    {
                        m_bUploadHd = TRUE;
                    }
                    else
                    {
                        m_bUploadHd = FALSE;
                    }

                    if (xmlBase.FindElem("capability") && "true" == xmlBase.GetData())
                    {
                        m_bUploadCapability = TRUE;
                    }
                    else
                    {
                        m_bUploadCapability = FALSE;
                    }

                    xmlBase.OutOfElem();
                }
                xmlBase.OutOfElem();
            }
        }
        else if (xmlBase.FindElem("eventMode") && "all" == xmlBase.GetData())
        {
            m_cmbAlarmSubscribeInfo.SetCurSel(0);
            OnCbnSelchangeComboAlarmSubscribeInfo();

            if (xmlBase.FindElem("ChangedUploadSub") && xmlBase.IntoElem())
            {
                if (xmlBase.FindElem("StatusSub") && xmlBase.IntoElem())
                {
                    if (xmlBase.FindElem("all") && "true" == xmlBase.GetData())
                    {
                        m_bUploadAll = TRUE;
                    }
                    else
                    {
                        m_bUploadAll = FALSE;
                    }

                    if (xmlBase.FindElem("channel") && "true" == xmlBase.GetData())
                    {
                        m_bUploadChannel = TRUE;
                    }
                    else
                    {
                        m_bUploadChannel = FALSE;
                    }

                    if (xmlBase.FindElem("hd") && "true" == xmlBase.GetData())
                    {
                        m_bUploadHd = TRUE;
                    }
                    else
                    {
                        m_bUploadHd = FALSE;
                    }

                    if (xmlBase.FindElem("capability") && "true" == xmlBase.GetData())
                    {
                        m_bUploadCapability = TRUE;
                    }
                    else
                    {
                        m_bUploadCapability = FALSE;
                    }

                    xmlBase.OutOfElem();
                }
                xmlBase.OutOfElem();
            }

            if (xmlBase.FindElem("channels"))
            {
                m_bChannelEnable = TRUE;
                OnBnClickedCheckChannelEnable();
                for (int i = 0; i < m_listChan.GetItemCount(); i++)
                {
                    m_listChan.SetCheck(i, FALSE);

                    csTemp.Format("%d", m_listChan.GetItemData(i));

                    char *tokenPtr = strtok((char*)xmlBase.GetData().c_str(), ",");
                    while (tokenPtr != NULL)
                    {
                        if (tokenPtr == csTemp)
                        {
                            m_listChan.SetCheck(i, TRUE);
                            break;
                        }
                        tokenPtr = strtok(NULL, ",");
                    }
                }
            }
            else
            {
                m_bChannelEnable = FALSE;
                OnBnClickedCheckChannelEnable();
            }

            if (xmlBase.FindElem("pictureURLType"))
            {
                for (int i = 0; i < m_comboPictureUrlType.GetCount(); i++)
                {
                    m_cmbAlarmSubscribeInfo.GetLBText(i, csTemp);

                    if (csTemp == xmlBase.GetData().c_str())
                    {
                        m_comboPictureUrlType.SetCurSel(i);
                    }
                }
            }
            else
            {
                m_comboPictureUrlType.SetCurSel(0);
            }
        }
        xmlBase.OutOfElem();
    }
}



/** @fn void CAlarmAdvanceSetter::OnBnClickedCheckChannelEnable()
 *  @brief ͨʹܵ¼
 *  @return void
 */

void CAlarmAdvanceSetter::OnBnClickedCheckChannelEnable()
{
    // TODO:  ڴӿؼ֪ͨ
    UpdateData(TRUE);
    GetDlgItem(IDC_LIST_CHAN)->EnableWindow(m_bChannelEnable);
}

/** @fn void CAlarmAdvanceSetter::GetSubcribeCapability()
 *  @brief ȡ
 *  @return void
 */

void CAlarmAdvanceSetter::GetSubcribeCapability()
{

    NET_DVR_XML_CONFIG_INPUT  xmlConfigInput = { 0 };
    NET_DVR_XML_CONFIG_OUTPUT  xmlCongfigOutput = { 0 };
    xmlConfigInput.dwSize = sizeof(xmlConfigInput);
    xmlCongfigOutput.dwSize = sizeof(xmlCongfigOutput);

    char szUrl[256] = "";
    DWORD dwOutputLen = 1024 * 1024;
    char *pOutBuf = new char[dwOutputLen];

    BOOL bIsSupportFaceMatchBroken = FALSE;

    sprintf(szUrl, "GET /ISAPI/Event/notification/subscribeEventCap");
    xmlConfigInput.lpRequestUrl = szUrl;
    xmlConfigInput.dwRequestUrlLen = strlen(szUrl);

    memset(pOutBuf, 0, dwOutputLen);
    xmlCongfigOutput.dwOutBufferSize = dwOutputLen;
    xmlCongfigOutput.lpOutBuffer = pOutBuf;

    if (NET_DVR_STDXMLConfig(g_struDeviceInfo[m_iDeviceIndex].lLoginID, &xmlConfigInput, &xmlCongfigOutput))
    {
        CXmlBase xmlBase;
        xmlBase.Parse(pOutBuf);

        if ((xmlBase.FindElem("SubscribeEventCap") && xmlBase.IntoElem()))
        {
            //жǷ֧ͨ
            if (xmlBase.FindElem("channelMode"))
            {
                GetDlgItem(IDC_CHECK_CHANNEL_ENABLE)->EnableWindow(FALSE);
                if (xmlBase.GetAttributeValue("opt").find("list"))
                {
                    GetDlgItem(IDC_CHECK_CHANNEL_ENABLE)->EnableWindow(TRUE);
                }
            }
            //жǷ֧¼
            if (xmlBase.FindElem("eventMode"))
            {
                m_cmbAlarmSubscribeInfo.ResetContent();
                int iIndex = 0;
                CString strTmp = strtok((char*)xmlBase.GetAttributeValue("opt").c_str(), ",");
                while (strTmp != _T(""))
                {
                    strTmp.TrimLeft();
                    m_cmbAlarmSubscribeInfo.InsertString(iIndex, strTmp);
                    iIndex++;

                    strTmp = strtok(NULL, ",");
                }

                m_cmbAlarmSubscribeInfo.SetCurSel(0);
            }
            //ֶ֧¼
            if (xmlBase.FindElem("EventList") && xmlBase.IntoElem())
            {
                m_comboEventType.ResetContent();
                int iIndex = 0;
                do
                {
                    if (xmlBase.FindElem("Event") && xmlBase.IntoElem())
                    {
                        if (xmlBase.FindElem("type"))
                        {
                            m_listSubcirbeEventCap[iIndex].strEventType = xmlBase.GetData();
                            m_comboEventType.InsertString(iIndex, xmlBase.GetData().c_str());

                            if (xmlBase.FindElem("pictureURLType"))
                            {
                                m_listSubcirbeEventCap[iIndex].strPictureUrlType = xmlBase.GetAttributeValue("opt");
                                m_listSubcirbeEventCap[iIndex].strDefaultPictureUrlType = xmlBase.GetAttributeValue("def");
                            }
                            iIndex++;
                        }
                        xmlBase.OutOfElem();
                    }
                } while (xmlBase.NextSibElem());

                m_comboEventType.SetCurSel(0);

                xmlBase.OutOfElem();
            }
            //жǷ֧ͼƬʽ
            if (xmlBase.FindElem("pictureURLType"))
            {
                m_comboPictureUrlType.ResetContent();
                m_strAllPictureUrlType = xmlBase.GetAttributeValue("opt");

                int iIndex = 0;
                CString strTmp = strtok((char *)m_strAllPictureUrlType.c_str(), ",");
                while (strTmp != _T(""))
                {
                    strTmp.TrimLeft();
                    m_comboPictureUrlType.InsertString(iIndex, strTmp);
                    iIndex++;

                    strTmp = strtok(NULL, ",");
                }
                m_comboPictureUrlType.SetCurSel(0);
                //ʱʹĬϵͼƬurlʽ
            }

            xmlBase.OutOfElem();
        }
    }
    else
    {
        m_cmbAlarmSubscribeInfo.EnableWindow(FALSE);
        GetDlgItem(IDC_CHECK_CHANNEL_ENABLE)->EnableWindow(FALSE);
        GetDlgItem(IDC_COMBO_EVENT_TYPE)->EnableWindow(FALSE);
        GetDlgItem(IDC_COMBO_PICTURE_URL_TYPE)->EnableWindow(FALSE);
    }
    if (pOutBuf != NULL)
    {
        delete[]pOutBuf;
        pOutBuf = NULL;
    }
}



/** @fn void CAlarmAdvanceSetter::OnCbnSelchangeComboEventType()
 *  @brief ¼лӦ
 *  @return void
 */

void CAlarmAdvanceSetter::OnCbnSelchangeComboEventType()
{
    // TODO:  ڴӿؼ֪ͨ
    if (!m_bCheckSubcribeCap)//УʱĬлʱʾͼƬURL
    {
        return;
    }
    CString strSubscribeType = _T("");
    m_cmbAlarmSubscribeInfo.GetLBText(m_cmbAlarmSubscribeInfo.GetCurSel(), strSubscribeType);
    if (strSubscribeType == "all")
    {
        //ԭͼƬurlб
        m_comboPictureUrlType.ResetContent();
        m_comboPictureUrlType.SetWindowText("");
        //¼ͼƬurlʾ
        if (m_strAllPictureUrlType != _T(""))
        {
            if (m_strAllPictureUrlType.find(","))
            {
                int iIndex = 0;
                CString strTmp = strtok((char*)m_strAllPictureUrlType.c_str(), ",");
                while (strTmp != _T(""))
                {
                    strTmp.TrimLeft();
                    m_comboPictureUrlType.InsertString(iIndex, strTmp);
                    iIndex++;

                    strTmp = strtok(NULL, ",");
                }
            }
            else
            {
                m_comboPictureUrlType.InsertString(0, m_strAllPictureUrlType.c_str());
            }
            m_comboPictureUrlType.SetCurSel(0);
        }

    }
    else if (strSubscribeType == "list")
    {
        //ԭͼƬurlб
        m_comboPictureUrlType.ResetContent();
        m_comboPictureUrlType.SetWindowText("");
        //ݵǰ¼ͼƬurlʾ
        CString strEventType = _T("");
        m_comboEventType.GetLBText(m_comboEventType.GetCurSel(), strEventType);
        for (int i = 0; i < MAX_EVENT_TYPE_NUM; i++)
        {
            if (m_listSubcirbeEventCap[i].strEventType.c_str() == strEventType)
            {
                if (m_listSubcirbeEventCap[i].strPictureUrlType != _T(""))
                {
                    if (m_listSubcirbeEventCap[i].strPictureUrlType.find(","))
                    {
                        int iIndex = 0;
                        CString strTmp = strtok((char*)m_listSubcirbeEventCap[i].strPictureUrlType.c_str(), ",");
                        while (strTmp != _T(""))
                        {
                            strTmp.TrimLeft();
                            m_comboPictureUrlType.InsertString(iIndex, strTmp);
                            iIndex++;

                            strTmp = strtok(NULL, ",");
                        }
                    }
                    else
                    {
                        m_comboPictureUrlType.InsertString(0, m_listSubcirbeEventCap[i].strPictureUrlType.c_str());
                    }
                    m_comboPictureUrlType.SetCurSel(0);
                }
            }
        }
    }
}


void CAlarmAdvanceSetter::OnBnClickedCheckSubcribeCap()
{
    // TODO:  ڴӿؼ֪ͨ
    UpdateData(TRUE);
    if (m_bCheckSubcribeCap && m_iDeviceIndex != -1)
    {
        GetSubcribeCapability();
    }
    else
    {
        InitEventType();
        m_comboPictureUrlType.ResetContent();
        m_comboPictureUrlType.InsertString(0, "def");
        m_comboPictureUrlType.InsertString(1, "binary");
        m_comboPictureUrlType.InsertString(2, "localURL");
        m_comboPictureUrlType.InsertString(3, "cloudStorageURL");
        m_comboPictureUrlType.SetCurSel(0);
    }
    UpdateData(FALSE);
}
